/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsPIAccessible.idl
 */

#ifndef __gen_nsPIAccessible_h__
#define __gen_nsPIAccessible_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIAccessible; /* forward declaration */

class nsIAccessibleEvent; /* forward declaration */


/* starting interface:    nsPIAccessible */
#define NS_PIACCESSIBLE_IID_STR "e4865da3-f292-4f1a-9c56-dd307f1bdc17"

#define NS_PIACCESSIBLE_IID \
  {0xe4865da3, 0xf292, 0x4f1a, \
    { 0x9c, 0x56, 0xdd, 0x30, 0x7f, 0x1b, 0xdc, 0x17 }}

class NS_NO_VTABLE nsPIAccessible : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_PIACCESSIBLE_IID)

  /**
   * Set accessible parent.
   */
  /* void setParent (in nsIAccessible aAccParent); */
  NS_IMETHOD SetParent(nsIAccessible *aAccParent) = 0;

  /**
   * Set first accessible child.
   */
  /* void setFirstChild (in nsIAccessible aAccFirstChild); */
  NS_IMETHOD SetFirstChild(nsIAccessible *aAccFirstChild) = 0;

  /**
   * Set next sibling accessible.
   */
  /* void setNextSibling (in nsIAccessible aAccNextSibling); */
  NS_IMETHOD SetNextSibling(nsIAccessible *aAccNextSibling) = 0;

  /**
   * Return parent accessible only if cached.
   */
  /* void getCachedParent (out nsIAccessible aAccParent); */
  NS_IMETHOD GetCachedParent(nsIAccessible **aAccParent) = 0;

  /**
   * Set the child count to -1 (unknown) and null out cached child pointers
   */
  /* void invalidateChildren (); */
  NS_IMETHOD InvalidateChildren(void) = 0;

  /**
   * Fire accessible event.
   *
   * @param aEvent - DOM event
   * @param aTarget - target of DOM event
   * @param aData - additional information for accessible event.
   *
   * XXX: eventually this method will be removed (see bug 377022)
   */
  /* void fireToolkitEvent (in unsigned long aEvent, in nsIAccessible aTarget, in voidPtr aData); */
  NS_IMETHOD FireToolkitEvent(PRUint32 aEvent, nsIAccessible *aTarget, void * aData) = 0;

  /**
   * Fire accessible event.
   */
  /* void fireAccessibleEvent (in nsIAccessibleEvent aAccEvent); */
  NS_IMETHOD FireAccessibleEvent(nsIAccessibleEvent *aAccEvent) = 0;

  /**
   * Return true if there are accessible children in anonymous content
   */
  /* readonly attribute boolean allowsAnonChildAccessibles; */
  NS_IMETHOD GetAllowsAnonChildAccessibles(PRBool *aAllowsAnonChildAccessibles) = 0;

  /**
   * Assert if child not in parent's cache.
   */
  /* void testChildCache (in nsIAccessible aCachedChild); */
  NS_IMETHOD TestChildCache(nsIAccessible *aCachedChild) = 0;

  /**
   * Returns text of accessible if accessible has text role otherwise empty
   * string.
   */
  /* AString getContentText (); */
  NS_IMETHOD GetContentText(nsAString & _retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsPIAccessible, NS_PIACCESSIBLE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSPIACCESSIBLE \
  NS_IMETHOD SetParent(nsIAccessible *aAccParent); \
  NS_IMETHOD SetFirstChild(nsIAccessible *aAccFirstChild); \
  NS_IMETHOD SetNextSibling(nsIAccessible *aAccNextSibling); \
  NS_IMETHOD GetCachedParent(nsIAccessible **aAccParent); \
  NS_IMETHOD InvalidateChildren(void); \
  NS_IMETHOD FireToolkitEvent(PRUint32 aEvent, nsIAccessible *aTarget, void * aData); \
  NS_IMETHOD FireAccessibleEvent(nsIAccessibleEvent *aAccEvent); \
  NS_IMETHOD GetAllowsAnonChildAccessibles(PRBool *aAllowsAnonChildAccessibles); \
  NS_IMETHOD TestChildCache(nsIAccessible *aCachedChild); \
  NS_IMETHOD GetContentText(nsAString & _retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSPIACCESSIBLE(_to) \
  NS_IMETHOD SetParent(nsIAccessible *aAccParent) { return _to SetParent(aAccParent); } \
  NS_IMETHOD SetFirstChild(nsIAccessible *aAccFirstChild) { return _to SetFirstChild(aAccFirstChild); } \
  NS_IMETHOD SetNextSibling(nsIAccessible *aAccNextSibling) { return _to SetNextSibling(aAccNextSibling); } \
  NS_IMETHOD GetCachedParent(nsIAccessible **aAccParent) { return _to GetCachedParent(aAccParent); } \
  NS_IMETHOD InvalidateChildren(void) { return _to InvalidateChildren(); } \
  NS_IMETHOD FireToolkitEvent(PRUint32 aEvent, nsIAccessible *aTarget, void * aData) { return _to FireToolkitEvent(aEvent, aTarget, aData); } \
  NS_IMETHOD FireAccessibleEvent(nsIAccessibleEvent *aAccEvent) { return _to FireAccessibleEvent(aAccEvent); } \
  NS_IMETHOD GetAllowsAnonChildAccessibles(PRBool *aAllowsAnonChildAccessibles) { return _to GetAllowsAnonChildAccessibles(aAllowsAnonChildAccessibles); } \
  NS_IMETHOD TestChildCache(nsIAccessible *aCachedChild) { return _to TestChildCache(aCachedChild); } \
  NS_IMETHOD GetContentText(nsAString & _retval) { return _to GetContentText(_retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSPIACCESSIBLE(_to) \
  NS_IMETHOD SetParent(nsIAccessible *aAccParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetParent(aAccParent); } \
  NS_IMETHOD SetFirstChild(nsIAccessible *aAccFirstChild) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetFirstChild(aAccFirstChild); } \
  NS_IMETHOD SetNextSibling(nsIAccessible *aAccNextSibling) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetNextSibling(aAccNextSibling); } \
  NS_IMETHOD GetCachedParent(nsIAccessible **aAccParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCachedParent(aAccParent); } \
  NS_IMETHOD InvalidateChildren(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->InvalidateChildren(); } \
  NS_IMETHOD FireToolkitEvent(PRUint32 aEvent, nsIAccessible *aTarget, void * aData) { return !_to ? NS_ERROR_NULL_POINTER : _to->FireToolkitEvent(aEvent, aTarget, aData); } \
  NS_IMETHOD FireAccessibleEvent(nsIAccessibleEvent *aAccEvent) { return !_to ? NS_ERROR_NULL_POINTER : _to->FireAccessibleEvent(aAccEvent); } \
  NS_IMETHOD GetAllowsAnonChildAccessibles(PRBool *aAllowsAnonChildAccessibles) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAllowsAnonChildAccessibles(aAllowsAnonChildAccessibles); } \
  NS_IMETHOD TestChildCache(nsIAccessible *aCachedChild) { return !_to ? NS_ERROR_NULL_POINTER : _to->TestChildCache(aCachedChild); } \
  NS_IMETHOD GetContentText(nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContentText(_retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public nsPIAccessible
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSPIACCESSIBLE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, nsPIAccessible)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void setParent (in nsIAccessible aAccParent); */
NS_IMETHODIMP _MYCLASS_::SetParent(nsIAccessible *aAccParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setFirstChild (in nsIAccessible aAccFirstChild); */
NS_IMETHODIMP _MYCLASS_::SetFirstChild(nsIAccessible *aAccFirstChild)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setNextSibling (in nsIAccessible aAccNextSibling); */
NS_IMETHODIMP _MYCLASS_::SetNextSibling(nsIAccessible *aAccNextSibling)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getCachedParent (out nsIAccessible aAccParent); */
NS_IMETHODIMP _MYCLASS_::GetCachedParent(nsIAccessible **aAccParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void invalidateChildren (); */
NS_IMETHODIMP _MYCLASS_::InvalidateChildren()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void fireToolkitEvent (in unsigned long aEvent, in nsIAccessible aTarget, in voidPtr aData); */
NS_IMETHODIMP _MYCLASS_::FireToolkitEvent(PRUint32 aEvent, nsIAccessible *aTarget, void * aData)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void fireAccessibleEvent (in nsIAccessibleEvent aAccEvent); */
NS_IMETHODIMP _MYCLASS_::FireAccessibleEvent(nsIAccessibleEvent *aAccEvent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean allowsAnonChildAccessibles; */
NS_IMETHODIMP _MYCLASS_::GetAllowsAnonChildAccessibles(PRBool *aAllowsAnonChildAccessibles)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void testChildCache (in nsIAccessible aCachedChild); */
NS_IMETHODIMP _MYCLASS_::TestChildCache(nsIAccessible *aCachedChild)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString getContentText (); */
NS_IMETHODIMP _MYCLASS_::GetContentText(nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsPIAccessible_h__ */
